Index: /DCWoRMS/trunk/src/schedframe/scheduling/policy/local/LocalManagementSystem.java
===================================================================
--- /DCWoRMS/trunk/src/schedframe/scheduling/policy/local/LocalManagementSystem.java	(revision 480)
+++ /DCWoRMS/trunk/src/schedframe/scheduling/policy/local/LocalManagementSystem.java	(revision 481)
@@ -4,9 +4,7 @@
 import eduni.simjava.Sim_system;
 import gridsim.Accumulator;
-import gridsim.GridSimTags;
-import gridsim.Gridlet;
 import gridsim.ResourceCalendar;
-import gridsim.gssim.WormsTags;
-import gridsim.gssim.filter.SubTaskFilter;
+import gridsim.gssim.DCWormsTags;
+import gridsim.gssim.filter.ExecTaskFilter;
 import gssim.schedframe.scheduling.ExecTask;
 import gssim.schedframe.scheduling.Executable;
@@ -27,9 +25,7 @@
 import qcg.shared.constants.BrokerConstants;
 import schedframe.ResourceController;
-import schedframe.events.scheduling.EventReason;
 import schedframe.events.scheduling.SchedulingEvent;
 import schedframe.events.scheduling.SchedulingEventType;
 import schedframe.events.scheduling.StartTaskExecutionEvent;
-import schedframe.events.scheduling.TaskCanceledEvent;
 import schedframe.events.scheduling.TaskFinishedEvent;
 import schedframe.events.scheduling.TaskRequestedTimeExpiredEvent;
@@ -45,7 +41,7 @@
 import schedframe.scheduling.ResourceHistoryItem;
 import schedframe.scheduling.Scheduler;
+import schedframe.scheduling.TaskListImpl;
 import schedframe.scheduling.UsedResourceList;
 import schedframe.scheduling.WorkloadUnitHandler;
-import schedframe.scheduling.WorkloadUnitListImpl;
 import schedframe.scheduling.manager.resources.LocalResourceManager;
 import schedframe.scheduling.manager.resources.ManagedResources;
@@ -63,9 +59,8 @@
 import schedframe.scheduling.tasks.Job;
 import schedframe.scheduling.tasks.JobInterface;
-import schedframe.scheduling.tasks.SubmittedTask;
 import schedframe.scheduling.tasks.Task;
 import schedframe.scheduling.tasks.TaskInterface;
 import schedframe.scheduling.tasks.WorkloadUnit;
-import simulator.WormsConstants;
+import simulator.DCWormsConstants;
 import simulator.utils.DoubleMath;
 
@@ -112,8 +107,8 @@
 		switch (tag) {
 
-		case WormsTags.TIMER:
+		case DCWormsTags.TIMER:
 			if (pluginSupportsEvent(tag)) {
 				SchedulingEvent event = new SchedulingEvent(SchedulingEventType.TIMER);
-				SchedulingPlanInterface decision =  schedulingPlugin.schedule(event, 
+				SchedulingPlanInterface<?> decision =  schedulingPlugin.schedule(event, 
 						queues,  getJobRegistry(), getResourceManager(), moduleList);
 				executeSchedulingPlan(decision);
@@ -123,12 +118,12 @@
 			break;
 
-		case WormsTags.TASK_READY_FOR_EXECUTION:
+		case DCWormsTags.TASK_READY_FOR_EXECUTION:
 			
 			ExecTask data = (ExecTask) ev.get_data();
 			try {
-				data.setStatus(Gridlet.READY);
+				data.setStatus(DCWormsTags.READY);
 				if (pluginSupportsEvent(tag)) {
 					SchedulingEvent event = new StartTaskExecutionEvent(data.getJobId(), data.getId());
-					SchedulingPlanInterface decision =  schedulingPlugin.schedule(event,
+					SchedulingPlanInterface<?> decision =  schedulingPlugin.schedule(event,
 							queues,  getJobRegistry(), getResourceManager(), moduleList);
 					executeSchedulingPlan(decision);
@@ -139,15 +134,15 @@
 			break;
 
-		case WormsTags.TASK_EXECUTION_FINISHED:
+		case DCWormsTags.TASK_EXECUTION_FINISHED:
 			obj = ev.get_data();
-			ExecTask task = (ExecTask) obj;
-			if (task.getStatus() == Gridlet.INEXEC) {
-				finalizeExecutable(task);
-				SubmittedTask subTask = (SubmittedTask)task;
-				sendFinishedWorkloadUnit((ExecTask)subTask.getGridlet());
+			ExecTask exec = (ExecTask) obj;
+			if (exec.getStatus() == DCWormsTags.INEXEC) {
+				finalizeExecutable(exec);
+
+				sendFinishedWorkloadUnit(exec);
 				//task.setGridletStatus(Gridlet.SUCCESS);
 				//task.finalizeGridlet();
-				log.debug(task.getJobId() + "_" + task.getId() + " finished execution on " + new DateTime());
-				log.info(WormsConstants.USAGE_MEASURE_NAME + ": " + calculateTotalLoad(jobRegistry.getRunningTasks().size()));
+				log.debug(exec.getJobId() + "_" + exec.getId() + " finished execution on " + new DateTime());
+				log.info(DCWormsConstants.USAGE_MEASURE_NAME + ": " + calculateTotalLoad(jobRegistry.getRunningTasks().size()));
 				/*UsedResourceList<ResourceHistoryItem> lastUsedList = task.getUsedResources();
 				Map<ResourceUnitName, AbstractResourceUnit> lastUsed = lastUsedList.getLast()
@@ -163,10 +158,10 @@
 			}
 			if (pluginSupportsEvent(tag)) {
-				SchedulingEvent event = new TaskFinishedEvent(task.getJobId(), task.getId());
-				SchedulingPlanInterface decision = schedulingPlugin.schedule(event,
+				SchedulingEvent event = new TaskFinishedEvent(exec.getJobId(), exec.getId());
+				SchedulingPlanInterface<?> decision = schedulingPlugin.schedule(event,
 						queues, getJobRegistry(), getResourceManager(), moduleList);
 				executeSchedulingPlan(decision);
 			}
-			Job job = jobRegistry.getJob(task.getJobId());
+			Job job = jobRegistry.getJob(exec.getJobId());
 			if(!job.isFinished()){
 				getWorkloadUnitHandler().handleJob(job);
@@ -174,10 +169,10 @@
 
 			break;
-		case WormsTags.TASK_REQUESTED_TIME_EXPIRED:
+		case DCWormsTags.TASK_REQUESTED_TIME_EXPIRED:
 			obj = ev.get_data();
-			task = (SubmittedTask) obj;
+			exec = (Executable) obj;
 			if (pluginSupportsEvent(tag)) {
-				SchedulingEvent event = new TaskRequestedTimeExpiredEvent(task.getJobId(), task.getId());
-				SchedulingPlanInterface decision = schedulingPlugin.schedule(event,
+				SchedulingEvent event = new TaskRequestedTimeExpiredEvent(exec.getJobId(), exec.getId());
+				SchedulingPlanInterface<?> decision = schedulingPlugin.schedule(event,
 						queues, getJobRegistry(), getResourceManager(), moduleList);
 				executeSchedulingPlan(decision);
@@ -185,5 +180,5 @@
 
 			break;
-		case WormsTags.UPDATE:
+		case DCWormsTags.UPDATE:
 			updateProcessingTimes(ev);
 			break;
@@ -193,7 +188,7 @@
 
 	public void notifyReturnedWorkloadUnit(WorkloadUnit wu) {
-		if (pluginSupportsEvent(WormsTags.TASK_EXECUTION_FINISHED)) {
+		if (pluginSupportsEvent(DCWormsTags.TASK_EXECUTION_FINISHED)) {
 			SchedulingEvent event = new SchedulingEvent(SchedulingEventType.TASK_FINISHED);
-			SchedulingPlanInterface decision =  schedulingPlugin.schedule(event,
+			SchedulingPlanInterface<?> decision =  schedulingPlugin.schedule(event,
 					queues, getJobRegistry(), getResourceManager(), moduleList);
 			executeSchedulingPlan(decision);
@@ -203,117 +198,47 @@
 		//}
 	}
-
-	public void notifyCanceledWorkloadUnit(WorkloadUnit job) {
-
-		if (!pluginSupportsEvent(GridSimTags.GRIDLET_CANCEL))
-			return;
-
-		Executable executable = (Executable) job;
-		String jobID = executable.getJobId();
-
-		SchedulingPlanInterface decision = null;
-
-		try {
-			executable.setStatus((int) BrokerConstants.JOB_STATUS_CANCELED);
-
-			TaskCanceledEvent event = new TaskCanceledEvent(executable.getJobId(), executable.getTaskId());
-			event.setReason(EventReason.RESERVATION_EXCEEDED);
-			decision = schedulingPlugin
-					.schedule(event, queues, getJobRegistry(), getResourceManager(), moduleList);
-
-			if (decision == null)
-				return;
-
-			executeSchedulingPlan(decision);
-
-		} catch (Exception e) {
-			log.error("Exception during scheduling. " + e.getMessage());
-			e.printStackTrace();
-		}
-	}
-	
-	protected void executeSchedulingPlan(SchedulingPlanInterface decision) {
-
-		ArrayList<ScheduledTaskInterface> taskSchedulingDecisions = decision.getTasks();
+	
+	protected void executeSchedulingPlan(SchedulingPlanInterface<?> decision) {
+
+		ArrayList<ScheduledTaskInterface<?>> taskSchedulingDecisions = decision.getTasks();
 		for (int i = 0; i < taskSchedulingDecisions.size(); i++) {
-			try {
-				ScheduledTaskInterface taskDecision = taskSchedulingDecisions.get(i);
-
-				// not scheduled again are returned to the user.
-				if (taskDecision.getStatus() == AllocationStatus.REJECTED) {
-					continue;
+			ScheduledTaskInterface<?> taskDecision = taskSchedulingDecisions.get(i);
+
+			if (taskDecision.getStatus() == AllocationStatus.REJECTED) {
+				continue;
+			}
+
+			ArrayList<AllocationInterface<?>> allocations = taskDecision.getAllocations();
+
+			TaskInterface<?> task = taskDecision.getTask();
+			for (int j = 0; j < allocations.size(); j++) {
+
+				AllocationInterface<?> allocation = allocations.get(j);
+				if (allocation.isProcessing()) {
+					ExecTask exec = (ExecTask) task;					
+					executeTask(exec, allocation.getRequestedResources());
+				} else if(resourceManager.getSchedulerName(allocation.getProviderName()) != null){
+					allocation.setProviderName(resourceManager.getSchedulerName(allocation.getProviderName()));
+					submitTask(task, allocation);
+				} else {
+					ExecTask exec = (ExecTask) task;
+					executeTask(exec, chooseResourcesForExecution(allocation.getProviderName(), (ExecTask)task));
 				}
-
-				ArrayList<AllocationInterface> allocations = taskDecision.getAllocations();
-
-				WorkloadUnit task = taskDecision.getTask();
-				for (int j = 0; j < allocations.size(); j++) {
-
-					AllocationInterface allocation = allocations.get(j);
-					if (allocation.isProcessing()) {
-						
-						ExecTask exec = (ExecTask) task;
-						
-
-						//Executable e = (Executable)task;
-						/*SubmittedTask submittedTask = jobRegistry.getSubmittedTask(e.getJobId(), e.getId());
-						if(submittedTask == null)
-						{	submittedTask = new SubmittedTask(e);
-							jobRegistry.addTask(submittedTask);
-						}*/
-
-						/*e.visitResource(scheduler.get_name());
-						Scheduler parentScheduler = scheduler.getParent();
-						while (parentScheduler != null && !e.getVisitedResources().contains(parentScheduler.get_name())) {
-							e.visitResource(parentScheduler.get_name());
-							parentScheduler = parentScheduler.getParent();
-						}*/
-						
-												
-						executeTask(exec, allocation.getRequestedResources());
-					//} else if(GridSim.getEntityId(allocation.getProviderName()) != -1 || scheduler.getScheduler(allocation.getProviderName())!=null){
-					} else if(resourceManager.getSchedulerName(allocation.getProviderName()) != null){
-						allocation.setProviderName(resourceManager.getSchedulerName(allocation.getProviderName()));
-						submitWorkloadUnit(task, allocation);
-					} else {
-
-						ExecTask exec = (ExecTask) task;
-						
-							//Executable exec = jobRegistry.createExecutable(t, allocation);
-							//exec.setResourceParameter(scheduler.get_id(), 1);
-						/*e.visitResource(scheduler.get_name());
-						Scheduler parentScheduler = scheduler.getParent();
-						while (parentScheduler != null && !e.getVisitedResources().contains(parentScheduler.get_name())) {
-							e.visitResource(parentScheduler.get_name());
-							parentScheduler = parentScheduler.getParent();
-						}*/
-						executeTask(exec, chooseResourcesForExecution(allocation.getProviderName(), (ExecTask)task));
-					}
-				}
-
-			} catch (Exception e) {
-				e.printStackTrace();
-			}
+			}
+
 		}
 	}
 
 	protected void executeTask(ExecTask task, Map<ResourceUnitName, ResourceUnit> choosenResources) {
-	//	Executable exec = (Executable) task;
-	
-		SubmittedTask submittedTask = (SubmittedTask)task;
+
+		Executable exec = (Executable)task;
 		boolean allocationStatus = getAllocationManager().allocateResources(choosenResources);
 		if(allocationStatus == false)
 			return;
 		removeFromQueue(task);
-		//SubmittedTask submittedTask = (SubmittedTask)task;
-		/* submittedTask = jobRegistry.getSubmittedTask(exec.getJobId(), exec.getId());
-		if(submittedTask == null)
-		{	submittedTask = new SubmittedTask(exec);
-			jobRegistry.addTask(submittedTask);
-		}*/
-		double completionPercentage = (submittedTask.getLength() - submittedTask.getRemainingGridletLength())/submittedTask.getLength();
+		//double completionPercentage = (submittedTask.getLength() - submittedTask.getRemainingGridletLength())/submittedTask.getLength();
 		SchedulingEvent event = new SchedulingEvent(SchedulingEventType.START_TASK_EXECUTION);
 		int time = Double.valueOf(
-				execTimeEstimationPlugin.execTimeEstimation(event, task, choosenResources, completionPercentage)).intValue();
+				execTimeEstimationPlugin.execTimeEstimation(event, task, choosenResources, exec.getCompletionPercentage())).intValue();
 		log.debug(task.getJobId() + "_" + task.getId() + " starts executing on " + new DateTime()
 				+ " will finish after " + time);
@@ -322,25 +247,27 @@
 			return;
 
-		submittedTask.setEstimatedDuration(time);
+		exec.setEstimatedDuration(time);
 		DateTime currentTime = new DateTime();
 		ResourceHistoryItem resHistItem = new ResourceHistoryItem(choosenResources, currentTime);
-		submittedTask.addUsedResources(resHistItem);
-		submittedTask.setFinishTime(currentTime.getMillis() / 1000);
-		
-		jobRegistry.saveHistory(submittedTask, time, choosenResources);
-		
-		scheduler.sendInternal(time, WormsTags.TASK_EXECUTION_FINISHED,
-				submittedTask);
+		exec.addUsedResources(resHistItem);
+
+		scheduler.sendInternal(time, DCWormsTags.TASK_EXECUTION_FINISHED,
+				exec);
 
 		try {
-			long expectedDuration = submittedTask.getExpectedDuration().getMillis() / 1000;
-			scheduler.sendInternal(expectedDuration, WormsTags.TASK_REQUESTED_TIME_EXPIRED, submittedTask);
+			long expectedDuration = exec.getExpectedDuration().getMillis() / 1000;
+			scheduler.sendInternal(expectedDuration, DCWormsTags.TASK_REQUESTED_TIME_EXPIRED, exec);
 		} catch (NoSuchFieldException e) {
-			double t = submittedTask.getEstimatedDuration();
-			scheduler.sendInternal(t, WormsTags.TASK_REQUESTED_TIME_EXPIRED, submittedTask);
-		}
-		
-		submittedTask.setGridletStatus(Gridlet.INEXEC);
-		log.info(WormsConstants.USAGE_MEASURE_NAME + ": " + calculateTotalLoad(jobRegistry.getRunningTasks().size()));
+			double t = exec.getEstimatedDuration();
+			scheduler.sendInternal(t, DCWormsTags.TASK_REQUESTED_TIME_EXPIRED, exec);
+		}
+		
+		try {
+			exec.setStatus(DCWormsTags.INEXEC);
+		} catch (Exception e1) {
+			// TODO Auto-generated catch block
+			e1.printStackTrace();
+		}
+		log.info(DCWormsConstants.USAGE_MEASURE_NAME + ": " + calculateTotalLoad(jobRegistry.getRunningTasks().size()));
 		
 		PEUnit peUnit = (PEUnit)choosenResources.get(StandardResourceUnitName.PE);
@@ -348,5 +275,5 @@
 			ProcessingElements pes = (ProcessingElements) peUnit;
 			for (ComputingResource resource : pes) {
-				resource.handleEvent(new EnergyEvent(EnergyEventType.TASK_FINISHED, submittedTask));
+				resource.handleEvent(new EnergyEvent(EnergyEventType.TASK_FINISHED, exec));
 			}
 		} else {
@@ -357,5 +284,5 @@
 				
 			}
-			resource.handleEvent(new EnergyEvent(EnergyEventType.TASK_FINISHED, submittedTask));
+			resource.handleEvent(new EnergyEvent(EnergyEventType.TASK_FINISHED, exec));
 		}
 		/*ProcessingElements pes = (ProcessingElements) choosenResources.get(StandardResourceUnitName.PE);
@@ -371,10 +298,15 @@
 	}
 	
-	public void finalizeExecutable(ExecTask exec){
-		
-		SubmittedTask subTask = (SubmittedTask)exec;
-		subTask.setGridletStatus(Gridlet.SUCCESS);
-		subTask.finalizeGridlet();
-		UsedResourceList<ResourceHistoryItem> lastUsedList = subTask.getUsedResources();
+	public void finalizeExecutable(ExecTask execTask){
+		
+		Executable exec = (Executable)execTask;
+		try {
+			exec.setStatus(DCWormsTags.SUCCESS);
+		} catch (Exception e1) {
+			// TODO Auto-generated catch block
+			e1.printStackTrace();
+		}
+		exec.finalizeExecutable();
+		UsedResourceList<ResourceHistoryItem> lastUsedList = exec.getUsedResources();
 		Map<ResourceUnitName, ResourceUnit> lastUsed = lastUsedList.getLast()
 				.getResourceUnits();
@@ -385,5 +317,5 @@
 			ProcessingElements pes = (ProcessingElements) peUnit;
 			for (ComputingResource resource : pes) {
-				resource.handleEvent(new EnergyEvent(EnergyEventType.TASK_FINISHED, subTask));
+				resource.handleEvent(new EnergyEvent(EnergyEventType.TASK_FINISHED, exec));
 			}
 		} else {
@@ -394,5 +326,5 @@
 				
 			}
-			resource.handleEvent(new EnergyEvent(EnergyEventType.TASK_FINISHED, subTask));
+			resource.handleEvent(new EnergyEvent(EnergyEventType.TASK_FINISHED, exec));
 		}
 		/*ProcessingElements pes = (ProcessingElements) lastUsed.get(StandardResourceUnitName.PE);
@@ -400,19 +332,19 @@
 			resource.handleEvent(new EnergyEvent(EnergyEventType.TASK_FINISHED, subTask));
 		}*/
-		SubTaskFilter filter = new SubTaskFilter(subTask.getGridletID(), WormsTags.TASK_REQUESTED_TIME_EXPIRED);
+		ExecTaskFilter filter = new ExecTaskFilter(exec.getUniqueId(), DCWormsTags.TASK_REQUESTED_TIME_EXPIRED);
 		scheduler.sim_cancel(filter, null);
 		
-		Executable executable = (Executable) subTask.getGridlet();
-		Job job = jobRegistry.getJob(executable.getJobId());
+
+		Job job = jobRegistry.getJob(exec.getJobId());
 
 		Task task = null;
 		try {
-			task = job.getTask(executable.getTaskId());
+			task = job.getTask(exec.getTaskId());
 		} catch (NoSuchFieldException e) {
 			e.printStackTrace();
 		}
-		if(executable.getProcessesId() == null){
+		if(exec.getProcessesId() == null){
 			try {
-				task.setStatus(executable.getStatus());
+				task.setStatus(exec.getStatus());
 			} catch (Exception e) {
 				e.printStackTrace();
@@ -422,6 +354,6 @@
 			for(int i = 0; i < processesList.size(); i++){
 				AbstractProcesses processes = processesList.get(i);
-				if(processes.getId().equals(executable.getProcessesId())){
-					processes.setStatus(executable.getStatus());
+				if(processes.getId().equals(exec.getProcessesId())){
+					processes.setStatus(exec.getStatus());
 					break;
 				}
@@ -441,11 +373,11 @@
 		while (iter.hasNext()) {
 			ExecTask task = iter.next();
-			SubmittedTask subTask = (SubmittedTask)task;
-			UsedResourceList<ResourceHistoryItem> usedResourcesList = subTask.getUsedResources();
+			Executable exec = (Executable)task;
+			UsedResourceList<ResourceHistoryItem> usedResourcesList = exec.getUsedResources();
 			ResourceUnit unit = usedResourcesList.getLast().getResourceUnits()
 					.get(StandardResourceUnitName.PE);
 
 			double load = getMIShare(timeSpan, (PEUnit) unit);
-			subTask.updateGridletFinishedSoFar(load);
+			exec.setCompletionPercentage(100 * timeSpan/exec.getEstimatedDuration());
 			addTotalLoad(load);
 		}
@@ -471,6 +403,6 @@
 		updateProcessingProgress();
 		for (ExecTask task : jobRegistry.getRunningTasks()) {
-			SubmittedTask subTask = (SubmittedTask)task;
-			List<String> visitedResource = subTask.getVisitedResources();
+			Executable exec = (Executable)task;
+			List<String> visitedResource = exec.getVisitedResources();
 			String originResource = ev.get_data().toString();
 			if(!ArrayUtils.contains(visitedResource.toArray(new String[visitedResource.size()]), originResource)){
@@ -478,8 +410,8 @@
 			}
 			
-			Map<ResourceUnitName, ResourceUnit> choosenResources = subTask.getUsedResources().getLast().getResourceUnits();
-			double completionPercentage = (task.getLength() - subTask.getRemainingGridletLength())/task.getLength();
+			Map<ResourceUnitName, ResourceUnit> choosenResources = exec.getUsedResources().getLast().getResourceUnits();
+			//double completionPercentage = (task.getLength() - subTask.getRemainingGridletLength())/task.getLength();
 			double time = execTimeEstimationPlugin.execTimeEstimation(new SchedulingEvent(SchedulingEventType.RESOURCE_STATE_CHANGED), 
-					task, choosenResources, completionPercentage);
+					task, choosenResources, exec.getCompletionPercentage());
 
 			/*if(!subTask.getVisitedResources().contains(ev.get_data().toString())) {
@@ -487,10 +419,10 @@
 			}*/
 			//check if the new estimated end time is equal to the previous one; if yes the continue without update
-			if( DoubleMath.subtract((subTask.getExecStartTime() + subTask.getEstimatedDuration()), (new DateTime().getMillis()/1000 + time)) == 0.0){
+			if( DoubleMath.subtract((exec.getExecStartTime() + exec.getEstimatedDuration()), (new DateTime().getMillis()/1000 + time)) == 0.0){
 				continue;
 			}
-			SubTaskFilter filter = new SubTaskFilter(subTask.getGridletID(), WormsTags.TASK_EXECUTION_FINISHED);
+			ExecTaskFilter filter = new ExecTaskFilter(exec.getUniqueId(), DCWormsTags.TASK_EXECUTION_FINISHED);
 			scheduler.sim_cancel(filter, null);
-			scheduler.sendInternal(time, WormsTags.TASK_EXECUTION_FINISHED, task);
+			scheduler.sendInternal(time, DCWormsTags.TASK_EXECUTION_FINISHED, task);
 
 		}
@@ -577,63 +509,13 @@
 			}
 
-			/*try {
-				List<? extends ComputingResource> processingElements = resourceManager.getResourcesOfType(StandardResourceType.Processor);
-				List<ComputingResource> choosenResources = new ArrayList<ComputingResource>();
-				int peSize = processingElements.size();
-				for (int i = 0; i < peSize && cpuRequest > 0; i++) {
-					if (processingElements.get(i).getStatus() == ResourceStatus.FREE) {
-						choosenResources.add(processingElements.get(i));
-						cpuRequest--;
-					}
-				}
-				if (cpuRequest > 0)
-				{	
-					return null;
-				}
-				processingUnits = new ProcessingElements(choosenResources);
-			} catch (Exception e) {
-	
-				List<ResourceUnit> procResUnit = resourceManager.getDistributedResourceUnits(StandardResourceUnitName.PE);
-
-				for(ResourceUnit resUnit: procResUnit){
-					if (resUnit.getFreeAmount() >= cpuRequest)
-					{	
-						processingUnits = new PEUnit(resUnit.getResourceId(), cpuRequest, cpuRequest);
-						break;
-					} 
-				}
-			}*/
 			map.put(StandardResourceUnitName.PE, choosenPEUnits.get(0));
 		}
-		/*int memoryRequest;
-		try {
-			memoryRequest = Double.valueOf(task.getMemoryRequest()).intValue();
-		} catch (NoSuchFieldException e) {
-			memoryRequest = 0;
-		}
-		if (memoryRequest != 0) {
-			List<ResourceUnit> resUnit = resourceManager.getSharedResourceUnits().get(StandardResourceUnitName.MEMORY);
-
-			Memory memory = null;
-			for (ResourceUnit memUnit : resUnit) {
-				Memory m = (Memory) memUnit;
-
-				if (m.getFreeAmount() >= memoryRequest) {	
-					System.out.println(m.getResourceId()+ ";"+m.getAmount()+";"+m.getFreeAmount());
-					memory = new Memory(m, memoryRequest, memoryRequest);
-				}
-			}
-			if(memory == null)
-				return null;
-			map.put(StandardResourceUnitName.MEMORY, memory);
-		}*/
+
 		return  map;
 	}
-
-
-	
-	public void notifySubmittedWorkloadUnit(WorkloadUnit job, boolean ack) {
+	
+	public void notifySubmittedWorkloadUnit(WorkloadUnit wu, boolean ack) {
 		updateProcessingProgress();
-		registerWorkloadUnit(job);
+		registerWorkloadUnit(wu);
 	}
 
@@ -654,6 +536,6 @@
 			List<JobInterface<?>> jobsList = new ArrayList<JobInterface<?>>();
 			jobsList.add(job);
-			WorkloadUnitListImpl readyTasks = new WorkloadUnitListImpl();
-			for(Task task: jobRegistry.getReadyTasks(jobsList)){
+			TaskListImpl readyTasks = new TaskListImpl();
+			for(Task task: jobRegistry.getAvailableTasks(jobsList)){
 				task.setStatus((int)BrokerConstants.TASK_STATUS_QUEUED);
 				readyTasks.add(task);
@@ -667,17 +549,13 @@
 		public void handleTask(TaskInterface<?> ti){
 			Task task = (Task)ti;
-			
-			if(task.getProcesses() == null){
+			List<AbstractProcesses> processes = task.getProcesses();
+
+			if(processes == null || processes.size() == 0){
 				Executable exec = new Executable(task);
-				exec.setUserID(task.getSenderId());
-				exec.setLength(task.getLength());
 				registerWorkloadUnit(exec);
 			} else {
-				List<AbstractProcesses> processesList = task.getProcesses();
-				for(int i = 0; i < processesList.size(); i++){	
-					AbstractProcesses processes = processesList.get(i);
-					Executable exec = new Executable(task, processes);
-					exec.setUserID(task.getSenderId());
-					exec.setLength(task.getLength());
+				for(int j = 0; j < processes.size(); j++){
+					AbstractProcesses procesesSet = processes.get(j);
+					Executable exec = new Executable(task, procesesSet);
 					registerWorkloadUnit(exec);
 				}
@@ -701,34 +579,13 @@
 			}
 			
-			exec.setResourceParameter(scheduler.get_id(), 1);
-			SubmittedTask subTask = new SubmittedTask(exec);
-			jobRegistry.addTask(subTask);
-			WorkloadUnitListImpl newTasks = new WorkloadUnitListImpl();
-			newTasks.add(subTask);
-		
-			schedulingPlugin.placeJobsInQueues(newTasks, queues, getResourceManager(), moduleList);
-
-			if (subTask.getStatus() == Gridlet.QUEUED) {
+			exec.setSchedulerName(scheduler.get_id());
+			jobRegistry.addExecTask(exec);
+			TaskListImpl newTasks = new TaskListImpl();
+			newTasks.add(exec);
+		
+			schedulingPlugin.placeTasksInQueues(newTasks, queues, getResourceManager(), moduleList);
+
+			if (exec.getStatus() == DCWormsTags.QUEUED) {
 				sendExecutableReadyEvent(exec);
-			}
-		}
-		
-		public void handleSubmittedTask(SubmittedTask task){
-
-			task.visitResource(scheduler.get_name());
-			Scheduler parentScheduler = scheduler.getParent();
-			while (parentScheduler != null && !task.getVisitedResources().contains(parentScheduler.get_name())) {
-				task.visitResource(parentScheduler.get_name());
-				parentScheduler = parentScheduler.getParent();
-			}
-
-			jobRegistry.addTask(task);
-			WorkloadUnitListImpl newTasks = new WorkloadUnitListImpl();
-			newTasks.add(task);
-		
-			schedulingPlugin.placeJobsInQueues(newTasks, queues, getResourceManager(), moduleList);
-
-			if (task.getStatus() == Gridlet.QUEUED) {
-				sendExecutableReadyEvent(task);
 			}
 		}
Index: /DCWoRMS/trunk/src/schedframe/scheduling/policy/global/GridBroker.java
===================================================================
--- /DCWoRMS/trunk/src/schedframe/scheduling/policy/global/GridBroker.java	(revision 477)
+++ /DCWoRMS/trunk/src/schedframe/scheduling/policy/global/GridBroker.java	(revision 481)
@@ -19,5 +19,4 @@
 public class GridBroker extends GlobalManagementSystem { 
 
-	
 	private static Log log = LogFactory.getLog(GridBroker.class);
 
@@ -27,25 +26,11 @@
 	public GridBroker(String name, SchedulingPlugin schedulingPlugin, ExecutionTimeEstimationPlugin execTimeEstimationPlugin, TaskQueueList queues) throws Exception {
 		super(name, "BROKER",  schedulingPlugin, execTimeEstimationPlugin, queues);
-		
-		//make use of plug-in interface
-		
-		//Properties prop = new Properties();
-		//prop.put("plugin.name", name);
-		//prop.put("plugin.utils.timeoperations", "gssim.scheduling.plugin.local.GssimTimeOperations");
-		//schedulingPlugin.init(prop);
+
 		otherGridSchedulersIds = new HashSet<Integer>();
-		
 		moduleList = new ModuleListImpl(2);
-		//this.moduleList.add(new GridResourceDiscovery(this.getScheduler()));
-		//moduleList.add(new GridReservationManagerNew(this));
-		
-		if(log.isDebugEnabled())
-			log.debug(name + ": Creating a broker interface object");
 	}
 
 	public void init(Scheduler scheduler, ManagedResources managedResources) {
 		super.init(scheduler, managedResources);
-		//this.scheduler = scheduler;
-		//this.resourceManager = ResourceManagerFactory.createResourceManager(scheduler, managedResources);
 		this.moduleList.add((GridResourceDiscovery)resourceManager);
 	}
@@ -57,5 +42,4 @@
 		}
 		return providerIds;
-		//return GridSim.getGridResourceList();
 	}
 
